/*
 *	SynCom -- Library Functions
 *
 *	(c) 1999 Martin Mares <mj@ucw.cz>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "syncom.h"

void
die(char *msg, ...)
{
  va_list args;

  va_start(args, msg);
  vfprintf(stderr, msg, args);
  fputc('\n', stderr);
  va_end(args);
  exit(1);
}

void *
xmalloc(int size)
{
  void *x = malloc(size);
  if (!x)
    die("Unable to allocate %d bytes of memory", size);
  return x;
}
