#
#	SynCom -- Minimal Pascal Parser Skeleton
#
#	(c) 1999 Martin Mares <mj@ucw.cz>
#
#	Can be freely distributed and used under the terms of the GNU GPL.
#

T BEGIN begin
T END end
T DIV div
T MOD mod
T PROGRAM program
T VAR var
T TYPE type
T ASSIGN :=
T IF if
T THEN then
T ELSE else
T CASE case
T WHILE while
T DO do
T FOR for
T TO to
T DOWNTO downto
T TRUE true
T FALSE false
T LONGINT longint
T REPEAT repeat
T UNTIL until
T AND and
T OR or
T NE <>
T LE <=
T GE >=
T OF of
T SHL shl
T SHR shr
T XOR xor
T DBLDOT ..
T INTEGER integer
T REAL real
T SHORTINT shortint
T CHAR char
T WORD word
T BOOLEAN boolean
T RECORD record
T ARRAY array
T LABEL label
T PROCEDURE procedure
T FUNCTION function
T USES uses
T CONST const
T WITH with
T EXIT exit
T BREAK break
T CONTINUE continue
T NOT not
T STRING string
T FORWARD forward

O %left T_THEN
O %left T_ELSE
O %left '=' '<' '>' T_NE T_LE T_GE
O %left '+' '-'
O %left '*' '/' T_DIV T_MOD
O %left T_OR T_XOR
O %left T_AND
O %left T_SHL T_SHR
O %left '^' '.' '[' ']' '#'
O %right '@' T_NOT uminus

L NUM
L SYM
L STRING

X

D program
R prog1 decls T_BEGIN cmds T_END '.'

D prog1
R /* empty */
R T_PROGRAM L_SYM ';'
R T_PROGRAM L_SYM '(' args ')' ';'

D decls
R /* empty */
R decls T_USES symlist ';'
R decls constdecl
R decls typedecl
R decls vardecl
R decls labeldecl
R decls procfuncdecl

D cmds
R cmd
R cmds ';' cmd

D cmd
R /* empty */
R expr ':' cmd
R expr T_ASSIGN expr
R T_BEGIN cmds T_END
R T_IF expr T_THEN cmd
R T_IF expr T_THEN cmd T_ELSE cmd
R T_WHILE expr T_DO cmd
R T_REPEAT cmds T_UNTIL expr
R T_FOR expr T_ASSIGN expr T_TO expr T_DO cmd
R T_FOR expr T_ASSIGN expr T_DOWNTO expr T_DO cmd
R L_SYM '(' args ')'
R L_SYM
R T_CASE expr T_OF cmds ';' T_END
R T_CASE expr T_OF cmds ';' T_ELSE cmds T_END
R T_WITH expr T_DO cmd
R T_EXIT
R T_BREAK
R T_CONTINUE

D expr
R L_STRING
R L_NUM
R L_SYM
R T_TRUE
R T_FALSE
R '(' expr ')'
R expr '+' expr
R expr '-' expr
R expr '*' expr
R expr '/' expr
R expr T_DIV expr
R expr T_MOD expr
R expr T_AND expr
R expr T_OR expr
R expr T_XOR expr
R expr '=' expr
R expr T_NE expr
R expr '<' expr
R expr '>' expr
R expr T_LE expr
R expr T_GE expr
R expr T_SHL expr
R expr T_SHR expr
R '@' expr
R expr '^'
R expr '.' L_SYM
R L_SYM '(' args ')'
R expr '[' args ']'
R T_NOT expr
R basictype '(' expr ')'
R '#' L_NUM
R '-' expr %prec_uminus

D args
R expr
R args ',' expr

D constdecl
R T_CONST constant ';'
R constdecl constant ';'

D constant
R L_SYM '=' expr
R L_SYM ':' type '=' expr

D typedecl
R T_TYPE L_SYM '=' type ';'
R typedecl L_SYM '=' type ';'

D type
R L_SYM
R basictype
R T_ARRAY '[' type ']' T_OF type
R T_RECORD recitems T_END
R '^' type
R minexpr T_DBLDOT minexpr
R T_STRING '[' minexpr ']'
R '(' symlist ')'

D basictype
R T_INTEGER
R T_REAL
R T_SHORTINT
R T_LONGINT
R T_CHAR
R T_WORD
R T_BOOLEAN
R T_STRING
R T_PROCEDURE
R T_FUNCTION

D minexpr
R L_SYM
R L_NUM

D recitems
R /* empty */
R recitems symlist ':' type ';'

D vardecl
R T_VAR symlist ':' type ';'
R vardecl symlist ':' type ';'

D symlist
R L_SYM
R symlist ',' L_SYM

D labeldecl
R T_LABEL args ';'

D procfuncdecl
R T_PROCEDURE L_SYM funcargs ';' decls T_BEGIN cmds T_END ';'
R T_FUNCTION L_SYM funcargs ':' type ';' decls T_BEGIN cmds T_END ';'
R T_PROCEDURE L_SYM funcargs ';' T_FORWARD ';'
R T_FUNCTION L_SYM funcargs ':' type ';' T_FORWARD ';'

D funcargs
R /* empty */
R '(' fargs1 ')'

D fargs1
R farg2 ':' type
R fargs1 ';' farg2 ':' type

D farg1
R L_SYM
R T_VAR L_SYM

D farg2
R farg1
R farg2 ',' L_SYM
