/*
 *	SynCom -- General Declarations
 *
 *	(c) 1999 Martin Mares <mj@ucw.cz>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

/* generic hacks */

#define NORET __attribute__((noreturn))
#define CASE_INSENSITIVE
#undef FAKE_FORMAT

/* lib.c */

void *xmalloc(int);
void die(char *msg, ...) NORET;

/* tree.c */

struct node {
  struct node *children;	/* First child, NULL for leaves */
  struct node *sibling;		/* Next child of the same parent */
  int leaf;			/* Leaf (terminal) node */
  union {
    int id;			/* Non-terminals: Rule number */
    struct keyword *w;		/* Terminals: Keyword */
    char *t;			/* Terminals during decoding: Text */
  } u;
};

struct node *new_node(int id, ...);
struct node *new_leaf(struct keyword *w);
void dump_tree(struct node *n);

/* encode.c */

struct keyword {
  struct keyword *next, *sibling;
  int class, id;
  char w[1];
};

extern int lino;
extern struct node *root;

int read_input(char *buf, int max);
void error(char *msg, ...) NORET;
struct keyword *intern(char *w, int class);

/* lexer.l */

int yylex(void);

/* parse.y */

#define YYSTYPE struct node *
int yyparse(void);

/* huffman.c */

void huff_init(FILE *, int);
void huff_encode(int);
void huff_end_write(void);
int huff_decode(void);
